> For the complete documentation index, see [llms.txt](https://docs.hackle.io/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.hackle.io/en/development-guide/go/go-user-info.md).

# User Identifier & Properties

{% hint style="info" %}
User Identifier Management

User Identifiers are used for the purpose of uniquely identifying users. For information about the meaning and importance of User Identifiers and criteria for choosing them, refer to the [Managing User Identifiers](/en/getting-started/user-identifier.md) documentation.
{% endhint %}

### Using Your Own User Identifier

Because server-side SDKs cannot identify users on their own, you must **always pass the User Identifier directly as a parameter**. The identifier you pass can be a Primary Key you manage directly, a device identifier, a member ID, an email address, a hash value, or similar.

### Example

Here is an example of performing Variation Distribution and then sending a user event.

```go
import "github.com/hackle-io/hackle-go-sdk/hackle"

user := hackle.NewUserBuilder().ID("ae2182e0").Build()

// 테스트 그룹 분배
variation := hackleClient.Variation(42, user)

// 사용자 이벤트 전송
hackleClient.Track(event, user)
```

## Additional Identifiers

You can send additional identifiers beyond the default identifiers using the example code below.

```go
import "github.com/hackle-io/hackle-go-sdk/hackle"

user := hackle.NewUserBuilder().
    ID("ae2182e0").                 // 기본 제공 식별자
    DeviceID("ae2182e0").           // 디바이스 ID (핵클 통합 식별자 사용가능)
    UserID("143").                  // 사용자 ID (핵클 통합 식별자 사용가능)
    Identifier("myCustomId", "42"). // Custom ID
    Build()

```

## Property

The Hackle SDK supports adding properties to User objects.

* A property must be sent as a pair of a Property Key (key) and a Property Value (value).
* The maximum number of properties that can be added to a user object is 128.

<table><thead><tr><th width="133.04296875">Category</th><th width="127.60546875">Type</th><th>Constraints</th></tr></thead><tbody><tr><td>Property Key</td><td><code>string</code></td><td><ul><li>Character limit is 128 characters.</li><li>Case-insensitive.</li><li>For example, AGE and age are recognized as the same Property Key.</li></ul></td></tr><tr><td>Property Value</td><td><code>boolean</code>, <code>string</code>, <code>number</code>, <code>array</code></td><td><ul><li>For string type, the character limit is 1024 characters.</li><li>String type is case-sensitive.</li><li>For example, APPLE and apple are recognized as different Property Values.</li><li>For number type, up to 15 integer digits and up to 6 decimal places are supported.</li></ul></td></tr></tbody></table>

### Example

The User object is used as a parameter in Variation Distribution, Feature Flag Decision, and Event Tracking. In the example below, you can see that three properties (`age`, `grade`, `is_paying_user`) have been added.

```go
import "github.com/hackle-io/hackle-go-sdk/hackle"

user := hackle.NewUserBuilder().
    ID("ae2182e0").
    Property("age", 42).
    Property("grade", "GOLD").
    Property("is_paying_user", false).
    Build()

// 테스트 그룹 분배
variation := hackleClient.Variation(experimentKey, user)

// 기능 플래그 결정
featureOn := hackleClient.IsFeatureOn(featureKey, user)

// 사용자 이벤트 전송
hackleClient.track(event, user)
```


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation by asking a question.

Perform an HTTP GET request on the following URL with the `ask` and `goal` query parameters:

```
GET https://docs.hackle.io/en/development-guide/go/go-user-info.md?ask=<question>&goal=<user_goal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is what the user is ultimately trying to achieve, the reason they need the answer. Sharing it helps GitBook give you a better, more relevant answer. A goal is most helpful when it describes the outcome the user wants rather than restating the question. For example, with `ask=how do I create an API token`, a goal like `automate deployments from our CI pipeline` lets GitBook tailor the answer to that use case.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
